if (typeof (Avanade) == "undefined") { Avanade = { __namespace: true }; }
if (typeof (Avanade.Leonardo) == "undefined") { Avanade.Leonardo = { __namespace: true }; }

Avanade.Leonardo.DateTimeUtils = new function () {

    const _self = this;
    const timeFormat = "DD/MM/YYYY HH:mm";
    const dateFormat = "DD/MM/YYYY";



    _self.OnLoad = function (params) {
        //var active = ($('.username').text().indexOf('Santo Giuseppe') != -1 || parent.$('.username').text().indexOf('Santo Giuseppe') != -1) ? true : false;

        var europeanPreference = retrieveUserPreference();

        var active = europeanPreference ? true : false;
        if (!active) {
            _self.FloatingNumbersUSHandler();
            return;
        }

        _self.DateFormatHandler();
        _self.FloatingNumbersHandler();
        if (params) {
            if (params.subgrids) {
                setInterval(function () { _self.SubGridHandler(params.subgrids); }, 1000);
            }

            if (params.extraFields) {
                _self.ExtraFieldsHandler(params.extraFields);
            }
        }

        function retrieveUserPreference() {
            var value = $('#userdateformat').attr('value');
            if (value == 121800000)
                return true;
            return false;
        };
    };

    _self.DateFormatHandler = function () {

        var datetimeFields = retrieveDateTimeFields();
        var dateFields = retrieveOnlyDateFields();

        hideOOBDateTimePicker(datetimeFields);
        hideOOBDateTimePicker(dateFields);

        generateEUDateTimePicker(datetimeFields, timeFormat);
        generateEUDateTimePicker(dateFields, dateFormat);

        datetimeFields.forEach(function (item, index) {

            populateEUPicker(item);

        });

        dateFields.forEach(function (item, index) {

            populateEUPicker(item);

        });

        addOnChange(dateFields);
        addOnChange(datetimeFields);

        convertToEU_ReadOnlyForms();

        function retrieveDateTimeFields() {
            var selector = $('.input-append.input-group.datetimepicker');
            var fields = [];
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).children().first().attr('id').replace('_datepicker_description', '');
                var pickerFormat = $(selector[i]).children().first().attr('data-date-format');
                if (pickerFormat != 'MM/DD/YYYY' && pickerFormat != "M/D/YYYY")
                    fields.push(id);
            }
            return fields;
        };
        function retrieveOnlyDateFields() {
            var selector = $('.input-append.input-group.datetimepicker');
            var fields = [];
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).children().first().attr('id').replace('_datepicker_description', '');
                var pickerFormat = $(selector[i]).children().first().attr('data-date-format');
                if (pickerFormat == 'MM/DD/YYYY' || pickerFormat == "M/D/YYYY")
                    fields.push(id);
            }
            return fields;
        };

        function hideOOBDateTimePicker(fields) {
            fields.forEach(function (item, index) {
                $("input#" + item).parent().find($(".input-append.input-group.datetimepicker")).hide();
            });
        };

        function generateEUDateTimePicker(fields, format) {
            //genero elemento html datetimepicker
            fields.forEach(function (item, index) {
                var curStyle = $("#" + item + "_datepicker_description").attr('style');
                var readonly = $("#" + item + "_datepicker_description").attr('readonly');
                $("#" + item).parent().append(""
                    + "<div class='form-group'>"
                    + "	<div class='input-group date' id='datetimepicker__" + item + "'>"
                    + "		<input type='text' class='form-control' id='inputDate' value='' />"
                    + "		<span class='input-group-addon'><span class='glyphicon glyphicon-calendar'></span></span>"
                    + "	</div>"
                    + "</div>"
                );
                if (curStyle)
                    $("#datetimepicker__" + item + " > input").attr('style', curStyle);
                if (readonly)
                    $("#datetimepicker__" + item + " > input").attr('readonly', readonly);

                //istanzio il picker con formato 
                $('#datetimepicker__' + item).datetimepicker({
                    format: format
                })
            });

        };

        function addOnChange(fields) {
            fields.forEach(function (item, index) {
                $('#datetimepicker__' + item).on('dp.change', function (e) {
                    populateUSPicker(item);
                });
                $(document).on('change', '#datetimepicker__' + item + ' :input', function (e) {
                    populateUSPickerFromInput(item, $(this).val());
                });
            });
            fields.forEach(function (item, index) {
                $("input#" + item).parent().find($(".input-append.input-group.datetimepicker")).on('dp.change', function () {
                    populateEUPicker(item);
                });
            });
        };

        function populateUSPicker(field) {

            var date = $('#datetimepicker__' + field).data('date');
            finalDate = convertToUS(date);
            if (!isNaN(finalDate))
                $("input#" + field).parent().find($(".input-append.input-group.datetimepicker")).data("DateTimePicker").date(finalDate);
            else $("input#" + field).parent().find($(".input-append.input-group.datetimepicker")).data("DateTimePicker").date(null);
        }

        function populateUSPickerFromInput(field, value) {
            finalDate = convertToUS(value);
            if (!isNaN(finalDate))
                $("input#" + field).parent().find($(".input-append.input-group.datetimepicker")).data("DateTimePicker").date(finalDate);
            else $("input#" + field).parent().find($(".input-append.input-group.datetimepicker")).data("DateTimePicker").date(null);

        }
        function convertToUS(datetime) {
            var date = datetime.substring(0, 10);
            var time = datetime.substring(11, 19);
            var separator = "/";
            var dateParts = date.split(separator);
            if (time != "" && time != undefined && time != null) {
                var timeSeparator = ":";
                var timeParts = time.split(timeSeparator);
                var dateObject = new Date(+dateParts[2], dateParts[1] - 1, +dateParts[0], timeParts[0], timeParts[1]);
            } else {
                var dateObject = new Date(+dateParts[2], dateParts[1] - 1, +dateParts[0]);
            }
            return dateObject;
        }

        function populateEUPicker(field) {

            var date = $("input#" + field).parent().find($(".input-append.input-group.datetimepicker")).data('date');
            if (date == undefined)
                return;
            finalDate = convertToEU(date);
            if (!isNaN(finalDate))
                $('#datetimepicker__' + field).data("DateTimePicker").date(finalDate);
            else $('#datetimepicker__' + field).data("DateTimePicker").date(null);

        }

        function convertToEU(datetime) {
            datetime = datetime.split(" ");
            var date = datetime[0];
            var time = datetime[1];

            var separator = "/";
            var dateParts = date.split(separator);
            if (time != "" && time != undefined && time != null) {
                var timeSeparator = ":";
                var timeParts = time.split(timeSeparator);
                var dateObject = new Date(+dateParts[2], dateParts[0] - 1, +dateParts[1], timeParts[0], timeParts[1]);
            } else {
                var dateObject = new Date(+dateParts[2], dateParts[0] - 1, +dateParts[1]);
            }
            return dateObject;
        }


        function convertToEU_ReadOnlyForms() {
            //Nelle form di sola lettura i campi data non usano un elemento definito come in retrieveDateTimeFields.
            //Essi vengono identificati da uno specifico css e modificati senza generare un clone.
            //Viene inoltre aggiunto un il css lnd-datetime-readonly
            var toConvert = retrieveDateTimeFields_ReadOnlyForms();
            toConvert.each(function () {
                var e = $(this);
                var v = e.val();
                if (v) {
                    e.val(convertDatetimeToEU(v));
                }
            }).addClass('lnd-datetime-readonly');

            //Restituisce i campi data nelle form di sola lettura.
            function retrieveDateTimeFields_ReadOnlyForms() {
                return $('.datetimepicker > input.form-control.readonly[readonly]');
            }

            //Converte un testo di datetime da US in EU
            function convertDatetimeToEU(datetime) {
                if (datetime) {
                    var date = datetime.substring(0, 10);
                    var time = datetime.substring(11, 19);
                    var separator = "/";
                    var dateParts = date.split(separator);
                    var dateEUToString = '' + dateParts[1] + separator + dateParts[0] + separator + dateParts[2];

                    return dateEUToString + ' ' + time;
                }
                return datetime;
            }
        }
    };

    _self.FloatingNumbersHandler = function () {

        var fields = retrieveDecimalFields();
        generateClones(fields);
        addOnChange(fields);
        populateCloneOnLoad(fields);
        populateCloneOnOriginalChange(fields);
        hideOriginalField(fields);

        function populateCloneOnOriginalChange(fields) {
            fields.forEach(function (item, index) {
                $('#' + item).change(function () {
                    var value = $('#' + item).val();
                    $('#' + item + "__clone").val(value);
                    convertToEU(item + "__clone");
                });
            });
        }

        function convertToEU(item) {
            var number = $('#' + item).val();
            number = number.replace('.', ',');
            $('#' + item).val(number);
        }

        function populateCloneOnLoad(fields) {

            fields.forEach(function (item, index) {
                var number = $('#' + item).val();
                number = number.replace(',', '');
                number = number.replace('.', ',');
                $('#' + item + '__clone').val(number);
            });
        }

        function hideOriginalField(fields) {
            fields.forEach(function (item, index) {
                $('#' + item).hide();
            });
        };

        function addOnChange(fields) {
            fields.forEach(function (item, index) {
                $('#' + item + "__clone").change(function () {
                    var match = checkDecimals(item);
                    if (!match) {
                        alert("Error, invalid format!");
                        $('#' + item + "__clone").val(null);
                    }
                    var newValue = trimDecimals(item);
                    $('#' + item + "__clone").val(newValue);
                    newValue = newValue.replace(",", ".");
                    $('#' + item).val(newValue);
                    $('#' + item).trigger('change');
                });
            });
        };

        function generateClones(fields) {

            fields.forEach(function (item, index) {
                var clone = $('#' + item);
                clone.parent().append("<input id='" + item + "__clone' type='text' class='text decimal form-control  lnd-string'></div>");

                var original = $("#" + item + "__clone");
                if (clone.attr('style'))
                    original.attr('style', clone.attr('style'));
                if (clone.attr('readonly')) {
                    original.attr('readonly', clone.attr('readonly'));
                    original.addClass('readonly');
                }
            });
        };

        function retrieveDecimalFields() {
            var selector = $("input:text.decimal");
            var fields = [];
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).first().attr('id');
                fields.push(id);
            }
            selector = $("input:text.double");
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).first().attr('id');
                fields.push(id);
            }
            return fields;
        };

        function trimDecimals(field, numberOfDecimals) {

            var decimals = (numberOfDecimals == undefined || numberOfDecimals == "" || numberOfDecimals == null) ? 2 : numberOfDecimals;

            var number = $('#' + field + "__clone").val();
            number = number.replace('.', '');
            var position = number.indexOf(',');
            if (position == -1)
                return number;
            number = number.substring(0, position + decimals + 1);
            return number;

        };
        function checkDecimals(field) {
            debugger;
            let pattern = /^\d+\,?\d{1,2}$/;
            let pattern2 = /^\d/;
            var number = $('#' + field + "__clone").val();
            if (number.length > 1) {
                return result = number == '' || number.match(pattern) != null ? true : false;
            } else {
                return number.match(pattern2) != null ? true : false;
            }
        };

    };

    _self.SubGridHandler = function (subgridsSelector) {

        var CONVERTED_MARK = 'lnd-datetimeutils-subgrid-converted';
        var US_EU_MARK = 'us-eu';
        var CONVERTED_MARK_SELECTOR = '[' + CONVERTED_MARK + ']';
        var DATE_SELECTOR = '[data-type=System\\.DateTime]';
        var NUMBER_SELECTOR = '[data-type=System\\.Decimal]';
        var DOUBLE_SELECTOR = '[data-type=System\\.Double]';
        var POSTEDON_SELECTOR = 'td.postedon > .timeago';

        var subgrids = $(subgridsSelector);
        var i = 0;
        for (i = 0; i < subgrids.length; i++) {
            var grid = subgrids.eq(i);
            var dates = grid.find(DATE_SELECTOR).not(CONVERTED_MARK_SELECTOR);
            var numbers = grid.find(NUMBER_SELECTOR).not(CONVERTED_MARK_SELECTOR);
            var doubleNumbers = grid.find(DOUBLE_SELECTOR).not(CONVERTED_MARK_SELECTOR);
            var postedons = grid.find(POSTEDON_SELECTOR).not(CONVERTED_MARK_SELECTOR);
            convertDatetimeCellToEU(dates);
            convertNumberCellToEU(numbers);
            convertNumberCellToEU(doubleNumbers);
            convertPostedonCellToEU(postedons);
        }

        function convertDatetimeToEU(datetime) {
            if (datetime) {
                var date = datetime.substring(0, 10);
                var time = datetime.substring(11, 19);
                var separator = "/";
                var dateParts = date.split(separator);
                var dateEUToString = '' + dateParts[1] + separator + dateParts[0] + separator + dateParts[2];

                return dateEUToString + ' ' + time;
            }
            return datetime;
        }

        function convertDatetimeCellToEU(dates) {
            var i = 0;
            for (i = 0; i < dates.length; i++) {
                var cell = dates.eq(i);
                var datetime = cell.text();
                if (datetime) {
                    var v = convertDatetimeToEU(datetime);
                    cell.text(v);
                }
                markCellConverted(cell, US_EU_MARK);
            }

        }

        function convertNumberToEU(number) {
            if (number) {
                return number.replace(/,/g, "").replace(".", ",");
            }
            return number;
        }

        function convertNumberCellToEU(numbers) {
            var i = 0;
            for (i = 0; i < numbers.length; i++) {
                var cell = numbers.eq(i);
                var number = cell.text();
                if (number) {
                    cell.text(convertNumberToEU(number));
                }
                markCellConverted(cell, US_EU_MARK);
            }
        }

        function markCellConverted(cell, v) {
            cell.attr(CONVERTED_MARK, v);
        }

        function convertPostedonCellToEU(postedons) {
            for (var i = 0; i < postedons.length; i++) {
                var cell = postedons.eq(i);
                var datetime = cell.attr('title'); //Per questa casisistica di celle la data è nel titolo
                if (datetime) {
                    var v = convertDatetimeToEU(datetime);
                    cell.text(v);
                    cell.attr('title', v);
                }
                markCellConverted(cell, US_EU_MARK);
            }
        }

    }

    /*
     * La struttura di extraFieldsParams è la seguente:
     *    fieldSelectors:   array di oggetti | o singolo oggetto  per individuare i campi.
     *                      Ogni oggetto contterrà un campo selector e type. Entrambi obbligatori.
     *                      Il campo selector è il selettore per indicare uno o più campi dal DOM.
     *                      Il campo type è un indicazione del tipo del/dei campi per aiutare la libreria. Vedi le costant TYPE_XXX
     *                      
     *                      iframe, è un campo opzionale per indicare un iframe dove eseguire il selector jquery.
     *                      
     * Ad esempio, possibili valori corretti sono:
     *      - { selector: "#fooData", type: "datetimepicker", iframe: "salesorderitemquick" }
     *      - [ { selector: "#fooData", type: "datetimepicker" }, { selector: "#fieDiv > input.Decimal", type: "Decimal" } ]
     */
    _self.ExtraFieldsHandler = function (extraFieldsParams) {
        var PRINT_DEBUG = true;
        var INTERVAL_DURATION = 200;
        var CLONE_SUFFIX = "__clone";
        var TYPE_DECIMAL_READONLY = "decimal readonly";
        var TYPE_DATETIMEPICKER_READONLY = "datetimepicker readonly";
        var selectorsList; //Dopo la fase iniziale di controlli conterrà l'array con gli oggetti dei selettori
        if (!checkExtraFieldsParams(extraFieldsParams)) {
            return;
        }
        initSelectorsList();
        setInterval(function () { __extraFieldsHandler(); }, INTERVAL_DURATION);


        //Il main eseguito ad ogni intervallo.
        function __extraFieldsHandler() {
            for (var i = 0; i < selectorsList.length; i++) {
                //Da qui in poi si gestiscono i campi  di tipo selectorObj.type
                //individuati con il selettore selectorObj.selector nell'eventuale iframe selector.iframe
                var selectorObj = selectorsList[i];
                var fields = retrieveFields(selectorObj.selector, selectorObj.iframe);
                var type = selectorObj.type;

                var cloneMaker = null;
                if (type == TYPE_DECIMAL_READONLY) {
                    cloneMaker = cloneDecimalFieldReadonly;
                } else if (type == TYPE_DATETIMEPICKER_READONLY) {
                    cloneMaker = cloneDatetimepickerFieldReadonly;
                }

                if (cloneMaker) {
                    for (var k = 0; k < fields.length; k++) {
                        manageFieldReadonly(fields.eq(k), selectorObj, cloneMaker);
                    }
                }
            }
        }

        function manageFieldReadonly(ele, selectorObj, cloneMaker) {
            var cloneName = buildCloneName(ele.attr('id'));
            if (existsField("#" + cloneName, selectorObj.iframe)) {
                return;
            }

            cloneMaker(ele, cloneName);
        }


        //------------------------ HELPERS -----------------------------
        function buildCloneName(name) {
            return name + CLONE_SUFFIX;
        }

        function cloneDecimalFieldReadonly(ele, cloneName) {
            var eleClone = ele.clone().attr('id', cloneName).val(convertDecimalValueToEU(ele.val()));
            ele.hide().parent().append(eleClone);
        }

        function convertDecimalValueToEU(number) {
            if (number) {
                return number.replace(/,/g, "").replace(".", ",");
            }
            return number;
        }

        function cloneDatetimepickerFieldReadonly(ele, cloneName) {
            var eleClone = ele.clone().attr('id', cloneName)
                .attr('data-date-format', "DD/MM/YYYY")
                .val(convertDatetimeValueToEU(ele.val()));

            ele.hide().parent().append(eleClone);
        }

        function convertDatetimeValueToEU(datetime) {
            if (datetime) {
                var date = datetime.substring(0, 10);
                var time = datetime.substring(11, 19);
                var separator = "/";
                var dateParts = date.split(separator);
                var dateEUToString = '' + dateParts[1] + separator + dateParts[0] + separator + dateParts[2];

                return dateEUToString + ' ' + time;
            }
            return datetime;
        }

        /*
         * Esegue il selettore jQuery interrogando eventualmente la ricerca nell'iframe se è indicato in selectorObj.
         */
        function retrieveFields(selector, iframe) {
            if (iframe) {
                return $("#" + iframe).contents().find(selector);
            } else {
                return $(selector);
            }
        }

        /*
         * Restituisce true sse il selettore jQuery interrogando eventualmente la ricerca nell'iframe ha elementi.
         * Fa uso di retrieveFields.
         */
        function existsField(name, iframe) {
            return retrieveFields(name, iframe).length > 0;
        }

        /*
         * Restituisce true sse extraFieldsParams è un parametro valido per proseguire con la funzionalità
         * In caso di errore esegue una stampa di debug in console.
         */
        function checkExtraFieldsParams() {
            if (!extraFieldsParams || !extraFieldsParams.fieldSelectors) {
                //nessun parametro indicato ovvero la libreria non è stata richiesta necessaria.
                return false;
            }

            if ($.isArray(extraFieldsParams.fieldSelectors)) {
                var selectors = extraFieldsParams.fieldSelectors;
                if (selectors.length <= 0) {
                    printDebug("DateTimeUtils.ExtraFieldsHandler: impossible to continue since the parameter fieldSelectors was an empty array.");
                    return false;
                }

                for (var i = 0; i < selectors.length; i++) {
                    if (!checkSingleParameter(selectors[i]))
                        return false;
                }

                return true;
            }

            return checkSingleParameter(extraFieldsParams.fieldSelectors);

            //Verifica la struttura dell'oggetto di un singolo parametro
            function checkSingleParameter(p) {
                return (typeof p == "object") &&
                    (typeof p.selector == "string" && p.selector.length > 0) &&
                    (typeof p.type == "string" && p.type.length > 0);
            }
        }

        /*
         * Inizializza selectorsList.
         * Deve essere chiamata dopo la verifica che i parametri siano conformi con checkExtraFieldsParams.
         */
        function initSelectorsList() {
            if (!$.isArray(extraFieldsParams.fieldSelectors))
                selectorsList = [extraFieldsParams.fieldSelectors];
            else
                selectorsList = extraFieldsParams.fieldSelectors;
        }

        function printDebug(msg) {
            if (PRINT_DEBUG)
                console.log(msg);
        }

    }

    _self.FloatingNumbersUSHandler = function () {

        var fields = retrieveDecimalFields();

        addOnChange(fields);

        function addOnChange(fields) {
            if (!fields) {
                return;
            }

            fields.forEach(function (item, index) {
                $('#' + item).change(function () {
                    var match = checkDecimals(item);
                    if (!match) {
                        alert("Error, invalid format!");
                        $('#' + item).val(null);
                    }
                });
            });
        };

        function retrieveDecimalFields() {
            var selector = $("input:text.decimal");
            var fields = [];
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).first().attr('id');
                fields.push(id);
            }
            selector = $("input:text.double");
            for (var i = 0; i < selector.length; i++) {
                var id = $(selector[i]).first().attr('id');
                fields.push(id);
            }
            return fields;
        };

        function checkDecimals(field) {
            debugger;
            let pattern = /^\d+\.?\d{1,2}$/;
            let pattern2 = /^\d/;
            var number = $('#' + field).val();
            if (number.length > 1) {
                return result = number == '' || number.match(pattern) != null ? true : false;
            } else {
                return number.match(pattern2) != null ? true : false;
            }
        };

    };

};

